DECLARE SUB GetOffsets ()
DECLARE SUB FindPak ()
DECLARE SUB MakePak ()
DECLARE SUB AdjPalette ()
DECLARE SUB GetInputs ()
DECLARE SUB Savepcx ()
DECLARE SUB GetPalette ()
DECLARE SUB SavePalette ()
DECLARE SUB AdjColorTable ()
DECLARE SUB SaveColorTable ()
DEFDBL A-Z

CONST Quake1 = 1, Quake2 = 2, Hexen2 = 3, True = -1, False = 0
CONST infile = "IDGAMMA.DAT"

DIM colors(0 TO 63, 0 TO 255) AS INTEGER
DIM palet(0 TO 255, 1 TO 3) AS INTEGER


COMMON SHARED intensity, colorx, fullbright, game, Allowsat, Gamma
COMMON SHARED StartFile, StartPalette, Bytes, OutPalette
COMMON SHARED p AS STRING * 768, colors() AS INTEGER, palet() AS INTEGER
COMMON SHARED endtable, ch AS STRING * 1, OutFile AS STRING * 8
COMMON SHARED FoundPak AS INTEGER

   COLOR 15, 1: CLS
   PRINT "Idgamma version 1.1": PRINT
   COLOR 14, 1
   OutFile = "PAK?.PAK"
   

   IF LEN(DIR$(OutFile)) THEN

      GetInputs

      GetOffsets 'get offsets in idgamma.dat

      GetPalette
      AdjPalette

      'AdjColorTable
      'SaveColorTable

      FindPak
      IF NOT FoundPak THEN MakePak

      SavePalette
   ELSE
      PRINT "Cannot find any PAK files"
      PRINT "This Program must be run from the same directory as your PAK files"
      PRINT "Example directories are ID1, BASEQ2 or DATA1"
   END IF

SYSTEM

SUB AdjColorTable

   'make color table
   LOCATE 10, 1: PRINT "Processing light level:     % complete";

   FOR h = 0 TO 63
       LOCATE 10, 24: PRINT INT(1.587302 * h)
       IF h = 32 THEN
         FOR i = 0 TO 255
            colors(h, i) = i
            colors(h, i) = 15
         NEXT i
       ELSE
         FOR i = 1 TO 255
            r = palet(i, 1)
            g = palet(i, 2)
            b = palet(i, 3)
            total = r + g + b
            r = r * (64 - h) / 32
            g = g * (64 - h) / 32
            b = b * (64 - h) / 32

            IF r >= b AND r >= g THEN d = r / 255
            IF g >= r AND g >= b THEN d = g / 255
            IF b >= r AND r >= g THEN d = b / 255

            IF d > 1 THEN
               r = r / d
               g = g / d
               b = b / d
   '            r = (r + r / d) / 2
   '            g = (g + g / d) / 2
   '            b = (b + b / d) / 2
            END IF
            min = 9999
            FOR j = 0 TO 255
               r1 = palet(j, 1)
               g1 = palet(j, 2)
               b1 = palet(j, 3)
               'IF total <= palet(j, 0) THEN
                  dr = ((r1 - r) ^ 2 + (g1 - g) ^ 2 + (b1 - b) ^ 2) ^ .5
                  IF dr < min THEN
                     min = dr
                     colors(h, i) = j
                    ' IF min < 1 THEN EXIT FOR
                  END IF
               'END IF
            NEXT j
         NEXT i
       END IF
   NEXT h


END SUB

SUB AdjPalette

   ax = (255 * 3) / (2 + intensity)
'   ax = 0
   M = 1
   IF intensity <> 1 THEN M = (255 - ax) / (255 - ax / (intensity))
   
   Bx = 255 * (1 - M)

   offset = (255 - (255 * Gamma)) / (3 * intensity)

   FOR i = 0 TO 255

      
      r = palet(i, 1)
      g = palet(i, 2)
      b = palet(i, 3)
   

      IF i < fullbright OR (game = 2 AND i > 239) THEN
'         IF i > 0 THEN
            r = r + offset
            g = g + offset
            b = b + offset
'         END IF

         max = r
         IF g > max THEN max = g
         IF b > max THEN max = b

         Mult = intensity
         max = intensity * max


         SELECT CASE Allowsat
         CASE IS = 1
            Avg1 = (r + g + b) / 3
            Avg2 = intensity * Avg1
            IF Avg2 > ax THEN
               Avg2 = M * (Avg1 / intensity) + Bx '
               Mult = Avg2 / Avg1
            END IF
         CASE IS = 2 AND max > 255
            Mult = intensity * 255 / max
            r = r * Mult + ((255 - r * Mult) / (4 * intensity))
            g = g * Mult + ((255 - g * Mult) / (4 * intensity))
            b = b * Mult + ((255 - b * Mult) / (4 * intensity))
            Mult = 1
         CASE IS = 3 AND max > ax
            IF Allowsat = 2 THEN
               IF max > 255 THEN
                  Mult = Mult * (255 + max + max) / (max + max + max)
               END IF
            END IF
         END SELECT
         r = r * Mult
         g = g * Mult
         b = b * Mult

         IF r < 0 THEN r = 0
         IF g < 0 THEN g = 0
         IF b < 0 THEN b = 0

         IF r > 255 THEN r = 255
         IF g > 255 THEN g = 255
         IF b > 255 THEN b = 255

      END IF
      palet(i, 1) = r
      palet(i, 2) = g
      palet(i, 3) = b

   NEXT

END SUB

SUB FindPak

   c = 49  '"1"
   FoundPak = False
   DO
      MID$(OutFile, 4, 1) = CHR$(c)
      x$ = DIR$(OutFile)
      IF LEN(x$) > 0 THEN
         OPEN OutFile FOR BINARY AS 1
         length = LOF(1)
         CLOSE 1
         IF length = Bytes THEN FoundPak = True
      END IF
      c = c + 1
   LOOP UNTIL LEN(x$) = 0 OR FoundPak = True

END SUB

SUB GetcolorTable


CONST colormap = "COLORMAP.LMP"

'   IF DIR$(colormap) <> colormap THEN

      OPEN "COLORMAP.PCX" FOR BINARY AS 1
      x$ = ""
      i = 129
      DO
         GET #1, i, ch
         IF ch = "" THEN
            i = i + 1
            GET #1, i, ch
         END IF
         x$ = x$ + ch
         i = i + 1
      LOOP UNTIL LEN(x$) = 16385

      OPEN colormap FOR OUTPUT AS #2
      PRINT #2, x$;
      CLOSE
      endtable = i
'   END IF

END SUB

SUB GetInputs

   IF DIR$(infile) <> infile THEN PRINT "cannot find"; infile: SYSTEM
  
   OPEN infile FOR BINARY AS #1

   GET #1, 98695, game
   GET #1, , intensity
   GET #1, , Gamma
   GET #1, , Allowsat
   GET #1, , fullbright

   DO
      PRINT "Enter Game, (Quake1=1, Quake2=2, Hexen2=3)"
      PRINT "Game"; game;
      INPUT offset
   LOOP UNTIL offset > -1 AND offset < 4
   IF offset THEN game = INT(offset)


   PRINT
   PRINT "Enter Intensity, (1 = original, 1.5 is brighter)"
   PRINT "Intensity"; intensity;
   INPUT offset
   IF offset THEN intensity = offset

   PRINT
   PRINT "Enter Gamma, (1 = original, .8 is lighter)"
   PRINT "for quake2 use console vid_gamma instead"
   PRINT "Gamma"; Gamma;
   INPUT offset
   IF offset THEN Gamma = offset

   PRINT

   PRINT "Saturation is when brighter colors are replaced with white."
   PRINT "   / 1 = Little Saturation A,  3 = some Saturation  \"
   PRINT "   \ 2 = Little Saturation B,  4 = Allow Saturation /"
   PRINT "Allow Saturation"; Allowsat;
   INPUT offset
   IF offset THEN Allowsat = offset

   PRINT

   IF fullbright = 257 THEN x$ = "n)" ELSE x$ = "y)"
   PRINT "Some Fullbrights are used for explosions and fire"
   PRINT "Leave fullbrights Alone? (y/n) ("; x$;
   INPUT x$
   IF LEN(x$) > 0 AND game < 4 THEN
      IF LCASE$(MID$(x$, 1, 1)) = "y" THEN
         IF game = Quake1 THEN fullbright = 224
         IF game = Quake2 THEN fullbright = 208
         IF game = Hexen2 THEN fullbright = 240
      ELSE
         fullbright = 257
      END IF
   END IF

   PUT #1, 98695, game
   PUT #1, , intensity
   PUT #1, , Gamma
   PUT #1, , Allowsat
   PUT #1, , fullbright
   CLOSE
END SUB

SUB GetOffsets

'get offsets in idgamma.dat


   IF game = Quake2 THEN
      Bytes = 97004
      StartPalette = 96940
      StartFile = 769
      OutPalette = 96172
   ELSE
      Bytes = 844
      StartFile = 97773
      StartPalette = 97785
      OutPalette = 13
      IF game = Quake1 THEN StartPalette = 1
   END IF


END SUB

SUB GetPalette

   OPEN infile FOR BINARY AS 1
   GET #1, StartPalette, p
   CLOSE

   i = 0
   k = 0
   DO
      FOR j = 1 TO 3
         palet(i, j) = ASC(MID$(p, k + j, 1))
      NEXT
      i = i + 1
      k = k + 3
   LOOP UNTIL i >= 255

END SUB

SUB MakePak



DIM hdr AS STRING * 128
   

   OPEN infile FOR BINARY AS 1


   OPEN OutFile FOR OUTPUT AS 2

   SEEK #1, StartFile

   loops = Bytes \ 8192
   IF loops THEN
      x$ = SPACE$(8192)
      DO WHILE loops
         GET #1, , x$
         loops = loops - 1
         PRINT #2, x$;
      LOOP
   END IF
   rest = Bytes - SEEK(2) + 1

   IF rest THEN
      x$ = SPACE$(rest)
      GET #1, , x$
      PRINT #2, x$;
   END IF
   CLOSE
      

END SUB

SUB SaveColorTable


FOR h = 0 TO 63
    FOR i = 0 TO 255
      x$ = x$ + CHR$(colors(h, i))
    NEXT i
NEXT h

OPEN "gfx\colormap.lmp" FOR OUTPUT AS #1
PRINT #1, x$;
CLOSE

END SUB

SUB SavePalette


   i = 0
   k = 0
   DO
      FOR j = 1 TO 3
          MID$(p, j + k, 1) = CHR$(palet(i, j))
      NEXT
      i = i + 1
      k = k + 3
   LOOP UNTIL i >= 255


   OPEN OutFile FOR BINARY AS 1
   PUT #1, OutPalette, p
   CLOSE

PRINT OutFile; " created."

END SUB

